#ifndef __ABSTRACTRETOFACONVERTER_H__
#define __ABSTRACTRETOFACONVERTER_H__

#include <regexp/RegExp.h>
#include <automaton/FSM/FSM.h>

#include <AlibException.h>

#include "../include/macros.h"
#include "../abstract/Conversion.h"

namespace conversions
{

class AbstractREtoFAConverter : public Conversion
{
public:
    virtual automaton::FSM convert( void ) = 0;
    virtual ~AbstractREtoFAConverter( void );

protected:
    AbstractREtoFAConverter(const regexp::RegExp & re );

    const regexp::RegExp & m_re;
    automaton::FSM m_fsm;
};

} /* namespace conversions */

#endif /* __ABSTRACTRETOFACONVERTER_H__ */
