/*
 * AbstractREtoRRGConverter.h
 *
 *  Created on: 5. 3. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTRETORRGCONVERTER_H_
#define ABSTRACTRETORRGCONVERTER_H_

#include <regexp/RegExp.h>
#include <grammar/Regular/RightRegularGrammar.h>

#include "../../include/macros.h"
#include "../AbstractREtoRGConverter.h"

namespace conversions
{

class AbstractREtoRRGConverter: public conversions::AbstractREtoRGConverter
{
public:
    virtual ~AbstractREtoRRGConverter( void );
    virtual grammar::RightRegularGrammar convert( void ) = 0;

protected:
    AbstractREtoRRGConverter( const regexp::RegExp & re );
    grammar::RightRegularGrammar m_grammar;
};

} /* namespace conversions */

#endif /* ABSTRACTRETORRGCONVERTER_H_ */
