/*
 * AbstractLRGtoRRGConverter.h
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTLRGTORRGCONVERTER_H_
#define ABSTRACTLRGTORRGCONVERTER_H_

#include <grammar/Regular/LeftRegularGrammar.h>
#include <grammar/Regular/RightRegularGrammar.h>

#include "../../abstract/Conversion.h"

namespace conversions
{

class AbstractLRGtoRRGConverter : public Conversion
{
public:
    virtual ~AbstractLRGtoRRGConverter( void );
    virtual grammar::RightRegularGrammar convert( void ) = 0;

protected:
    AbstractLRGtoRRGConverter( const grammar::LeftRegularGrammar & lrg );

    const grammar::LeftRegularGrammar & m_lrg;
    grammar::RightRegularGrammar m_rrg;
};

} /* namespace conversions */

#endif /* ABSTRACTLRGTORRGCONVERTER_H_ */
