#ifndef __ABSTRACTFATOLRGCONVERTER_H__
#define __ABSTRACTFATOLRGCONVERTER_H__

#include <automaton/FSM/FSM.h>
#include <grammar/Regular/LeftRegularGrammar.h>
#include <AlibException.h>

#include "../../include/macros.h"
#include "../AbstractFAtoRGConverter.h"

namespace conversions
{

class AbstractFAtoLRGConverter : public AbstractFAtoRGConverter
{
public:
    virtual grammar::LeftRegularGrammar convert( ) = 0;
    virtual ~AbstractFAtoLRGConverter( void );

protected:
    grammar::LeftRegularGrammar m_grammar;

    AbstractFAtoLRGConverter( const automaton::FSM & automaton );
};

} /* namespace conversions */

#endif /* __ABSTRACTFATOLRGCONVERTER_H__ */
