#ifndef __ABSTRACTRGTOFACONVERTER_H__
#define __ABSTRACTRGTOFACONVERTER_H__

#include <automaton/FSM/FSM.h>
#include <AlibException.h>

#include "../include/macros.h"
#include "../abstract/Conversion.h"

namespace conversions
{

class AbstractRGtoFAConverter : public Conversion
{
public:
    virtual automaton::FSM convert( void ) = 0;
    virtual ~AbstractRGtoFAConverter( void );

protected:
    AbstractRGtoFAConverter( void );

    automaton::FSM m_automaton;
};

} /* namespace conversions */

#endif /* __ABSTRACTRGTOFACONVERTER_H__ */
