/*
 * RRGAlgebraic.h
 *
 *  Created on: 4. 3. 2014
 *      Author: tomas
 */

#ifndef RRGALGEBRAIC_H_
#define RRGALGEBRAIC_H_

#include "../../shared/equations/RightRegularEquationSolver.h"
#include "AbstractRRGtoREConverter.h"

namespace conversions
{

class RRGAlgebraic: public AbstractRRGtoREConverter
{
public:
    RRGAlgebraic( const grammar::RightRegularGrammar & rg );
    ~RRGAlgebraic( void );
    regexp::RegExp convert( void );

protected:
    RightRegularEquationSolver m_solver;
};

} /* namespace conversions */

#endif /* RRGALGEBRAIC_H_ */
